#!/bin/bash
#*******************************************************************************
# Copyright 2008, 2011 Hochschule Offenburg
# Klaus Dorer, Mathias Ehret, Stefan Glaser, Thomas Huber, Fabian Korak,
# Simon Raffeiner, Srinivasa Ragavan, Thomas Rinklin,
# Joachim Schilling, Ingo Schindler, Rajit Shahi, Bjoern Weiler
#
# This file is part of magmaOffenburg.
#
# magmaOffenburg is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# magmaOffenburg is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
#*******************************************************************************
###########################################
# Starts a series of game series.
# Assumes startGameSeries.sh is in same folder
#
# example: bash startSeriesOfGameSeries.sh team1.jar team2.jar 10 2 5 &
###########################################

if [ $# -ne 5 ]; then
        echo "Usage: $0 <team1.jar> <team2.jar> <start value> <step> <number of loops>"
        exit 1
fi

NUMBER_OF_GAMES=400
NUMBER_OF_PARALLEL_GAMES=4
TEAM1_NAME=team1
TEAM1_JAR=$1
TEAM2_NAME=team2
TEAM2_JAR=$2
AGENT_PORT=3100
TRAINER_PORT=3200
TRAINER_NAME=series
LOGFILE=outerrSS.log
START=$3
STEP=$4
LOOPS=$5



for ((i = 0 ; i < $LOOPS; i++ )) do
	# the parameter that is varied for the different series
	# make sure that one of the two binaries used uses this parameter!
	export VARIATION_PARAMETER=$(echo "scale=10;$START+$i*$STEP"|bc)
	#echo $VARIATION_PARAMETER
	
	# start one series
	bash startGameSeries.sh $NUMBER_OF_GAMES $NUMBER_OF_PARALLEL_GAMES $TEAM1_NAME $TEAM1_JAR $TEAM2_NAME $TEAM2_JAR 1 $AGENT_PORT $TRAINER_PORT $TRAINER_NAME$VARIATION_PARAMETER 1>log/$LOGFILE 2>&1 
done
