#*******************************************************************************
# Copyright 2008, 2011 Hochschule Offenburg
# Klaus Dorer, Mathias Ehret, Stefan Glaser, Thomas Huber, Fabian Korak,
# Simon Raffeiner, Srinivasa Ragavan, Thomas Rinklin,
# Joachim Schilling, Ingo Schindler, Rajit Shahi, Bjoern Weiler
#
# This file is part of magmaOffenburg.
#
# magmaOffenburg is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# magmaOffenburg is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
#*******************************************************************************
#!/bin/bash
###########################################
# Starts a magmaOffenburg RoboCup trainer on localhost
# example: ./startTrainer.sh 127.0.0.1 3100 3200 magma1 magma1.jar magma2 magma2.jar 11 trainer1
###########################################

if [ $# -ne 10 ]; then
  echo "Usage: $0 <serverIP> <agentport> <trainerport> <serverPid> <team1 name> <team1 jar> <team 2 name> <team2 jar> <number of players per team> <trainer name>"
  exit 1
fi

CLSPTH=./trainerOffenburg.jar
CLSPTH=${CLSPTH}:./commons-math3-3.3.jar

SERVER_IP=$1
AGENT_PORT=$2
TRAINER_PORT=$3
SERVER_PID=$4
TEAM1_NAME=$5
TEAM1_JAR=$6
TEAM2_NAME=$7
TEAM2_JAR=$8
NUM_OF_PLAYERS=$9
TRAINER_NAME=${10}

CMDLINE="--server=$SERVER_IP --agentPort=$AGENT_PORT --port=$TRAINER_PORT --serverPid=$SERVER_PID --referee=2"
CMDLINE="${CMDLINE} --team1=$TEAM1_NAME --team1Jar=$TEAM1_JAR --team2=$TEAM2_NAME --team2Jar=$TEAM2_JAR --players=$NUM_OF_PLAYERS"

java -cp $CLSPTH magma.monitor.RoboCupMonitor $CMDLINE 1>>log/$TRAINER_NAME.log 2>&1 

#java -cp $CLSPTH magma.tools.trainer.Trainer $SERVER_IP $SERVER_PORT $SERVER_PID 1>>log/$TRAINER_NAME.log 2>&1 
