/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 */

package magma.agent.action;

/**
 * 
 * @author kdorer
 */
public interface IEffector
{
	/**
	 * @return the name of this effector
	 */
	String getName();

	/**
	 * Sets the values of this effector as required by the specific effector
	 * @param values the number of float values required by the specific effector
	 */
	void setEffectorValues(float maxGain, float... values);

	/**
	 * Called to allow an effector to reset its state after it has been read for
	 * action.
	 */
	void resetAfterAction();

}
