/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.agent.action.impl;

import magma.agent.action.IEffector;

/**
 * Base class for all effectors
 * 
 * @author Klaus Dorer
 */
public abstract class Effector implements IEffector
{
	private final String name;

	/**
	 * Constructor
	 * 
	 * @param name Effector name
	 */
	Effector(String name)
	{
		super();
		this.name = name;
	}

	/**
	 * Retrieve effector name
	 * 
	 * @return Effector name
	 */
	public String getName()
	{
		return name;
	}

	@Override
	public void resetAfterAction()
	{
	}
}
