/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.agent.agentmodel;

import org.apache.commons.math3.geometry.euclidean.threed.Vector3D;

/**
 * SimSpark "ForceOrigin" sensor interface. Provides read-only access only.
 * 
 * @author Klaus Dorer
 */
public interface IForceResistance extends ISensor
{
	/**
	 * Retrieve the force origin (the point in 3-dimensional space the force
	 * effects on)
	 * 
	 * @return Force origin point
	 */
	Vector3D getForceOrigin();

	/**
	 * Retrieve the 3-dimensional force vector
	 * 
	 * @return Force vector
	 */
	Vector3D getForce();
}