/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 * 
 * This file is part of magmaOffenburg.
 * 
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg.  If not, see <http://www.gnu.org/licenses/>.
 ********************************************************************************/
package magma.agent.agentmodel;

/**
 * Represents a Motor of a joint
 */
public interface IMotor
{

	float getPerceivedAngle();

	void setPerceivedAngle(float angle);

	/**
	 * @param angle the new desired angle
	 * @return the speed to get to the desired angle
	 */
	float getNextSpeed(float angle);

	/**
	 * @return the max_speed
	 */
	float getMaxSpeed();

	/**
	 * @return the speed
	 */
	float getSpeed();

	/**
	 * @return the load
	 */
	float getLoad();

	/**
	 * @return the voltage
	 */
	float getVoltage();

	/**
	 * @return the temperature
	 */
	float getTemperature();

	/**
	 * @return the calculatedTemperature
	 */
	float getCalculatedTemperature();

	/**
	 * @return the calculatedTemperatureCoil
	 */
	float getCalculatedTemperatureCoil();

	byte getError();

	void setStiffness(float stiffness);

	float getStiffness();

	/**
	 * @return
	 */
	float getGain();

}