/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/

package magma.agent.agentmodel;

import java.util.Map;

import magma.agent.perception.IPerception;

/**
 * 
 * @author dorer
 */
public interface ISensor
{

	/**
	 * Retrieve the sensor name string
	 * 
	 * @return Sensor name
	 */
	String getName();

	/**
	 * Updates the joint values in the body model from perception
	 * @param perception the new perception we made
	 */
	void updateFromPerception(IPerception perception);

	/**
	 * Updates the joint values in the body model with no perception
	 */
	void updateNoPerception();

	/**
	 * @return a deep copy of this sensor
	 */
	ISensor copy();

	/**
	 * Adds this sensor the appropriate list depending if it is structured or not
	 * @param flatSensors
	 * @param structuredSensors
	 */
	void updateSensors(Map<String, ISensor> flatSensors,
			Map<String, ISensor> structuredSensors);
}