/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 */

package magma.agent.behavior;

/**
 * Interface for all underlying basic walk behaviors
 * @author kdorer
 */
public interface IBaseWalk extends IBehavior
{
	/**
	 * Instrumentation for the walk
	 * @param forwards_backwards percentage of forward backward speed (-100 is
	 *        backward)
	 * @param step_left_right percentage of sideward speed (-100 is right)
	 * @param turn_left_right degrees to turn (-values turn right)
	 * @param maxSpeedForward limit on the forward speed
	 */
	void setMovement(double forwards_backwards, double step_left_right,
			double turn_left_right, double maxSpeedForward, boolean hurry);
}
