/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/

package magma.agent.behavior;

/**
 * @author sturmflut
 */
@SuppressWarnings("all")
public interface IBehaviorConstants
{
	// General Behaviors
	String NONE = "none";

	String STOP = "stop";

	String BEAM_TO_POSITION = "beamToPosition";

	String BEAM_HOME = "beamHome";

	String SHUT_OFF = "shutOff";

	String GET_READY = "getReady";

	String MOVE_ZERO = "moveZero";

	// Say behaviors
	String SAY_POSITIONS_BEHAVIOR = "sayPositions";

	String SAY_SOMETHING = "saySomething";

	// Get Up behaviors
	String MOVE_ARM_TO_FALL_BACK = "moveArmToFallBack";

	String GET_UP_BACK = "getUpBack";

	String GET_UP_FRONT = "getUpFront";

	// Keep behaviors
	String KEEP_LEFT = "keepLeft";

	String KEEP_RIGHT = "keepRight";

	String KEEP = "keep";

	// Shoot behaviors
	String SWEATY_ATTACK = "SweatyAttack";

	String SHOOT_STRAIGHT = "shootStraight";

	String SHOOT_STRAIGHT_ONE_LEG_RIGHT = "shootStraightOneLegRight";

	String SHOOT_STRAIGHT_ONE_LEG_LEFT = "shootStraightOneLegLeft";

	String SHOOT_SLOMO_RIGHT = "shootSlomoRight";

	String SHOOT_SLOMO_LEFT = "shootSlomoleft";

	String SHOOT_LEFT_ONE_LEG = "shootLeftOneLeg";

	String SHOOT_RIGHT_ONE_LEG = "shootRightOneLeg";

	String SHOOT_BACK = "shootBack";

	String SHOOT_BACK_PULL = "shootBackPull";

	String SHOOT_SIDE_LEFT = "shootSideLeft";

	String SHOOT_SIDE_RIGHT = "shootSideRight";

	String KICK_CHIP_RIGHT = "kickChipRight";

	String KICK_CHIP_LEFT = "kickChipLeft";

	String KICK_SWEATY_LEFT = "KickSweaty_Left";

	String KICK_SWEATY_RIGHT = "KickSweaty_Right";

	// Celebrate/despair behaviors
	String WIN = "Win";

	String LOOSE = "Loose";

	// Movement behaviors

	String WALK = "Walk";

	String WALK_PATH = "WalkPath";

	String BALANCE = "Balance";

	String BASE_WALK = "BaseWalk";

	String WALKFORWARD = "WalkForward";

	String WALKSIDEWARD = "WalkSideward";

	String WALKTURNING = "WalkTurning";

	String STARTWALK = "StartWalk";

	String STOPWALK = "StopWalk";

	String RUN_TO_POSITION = "runToPosition";

	String RUN_PATH = "runPath";

	String DYNAMIC_WALK = "DynamicWalk";

	String DYNAMIC_WALK_DEMO1 = "DynamicWalkDemo1";

	String DYNAMIC_WALK_DEMO2 = "DynamicWalkDemo2";

	String WALK_BEHAVIOR_DEMO1 = "WalkBehaviorDemo1";

	String WALK_BEHAVIOR_DEMO2 = "WalkBehaviorDemo2";

	String STATIC_WALK = "StaticWalk";

	String IK2013_WALK = "IKWalkBehavior";

	String IK2013_STEP = "IKWalkStepBehavior";

	String IKSTEPPLAN = "IKStepPlanBehavior";

	String DYNAMIC_KICK_BEZIER = "DynamicKickBezier";

	String DYNAMIC_KICK_LEFT = "DynamicKickLeft";

	String DYNAMIC_KICK_RIGHT = "DynamicKickRight";

	String DYNAMIC_SLOMO_KICK_LEFT = "DynamicSlomoKickLeft";

	String DYNAMIC_SLOMO_KICK_RIGHT = "DynamicSlomoKickRight";

	String DYNAMIC_SIDEKICK_LEFT = "DynamicSidekickLeft";

	String DYNAMIC_SIDEKICK_RIGHT = "DynamicSidekickRight";

	String DYNAMIC_STATIC_KICK_LEFT = "DynamicStaticKickLeft";

	String DYNAMIC_STATIC_KICK_RIGHT = "DynamicStaticKickRight";

	String DYNAMIC_STATIC_SIDEKICK_LEFT = "DynamicStaticSidekickLeft";

	String DYNAMIC_STATIC_SIDEKICK_RIGHT = "DynamicStaticSidekickRight";

	String SLOMO_KICK_LEFT = "SlomoKickLeft";

	String SLOMO_KICK_RIGHT = "SlomoKickRight";

	String STABILIZE_ON_LEFT_LEG = "StabilizeOnLeftLeg";

	String STABILIZE_ON_RIGHT_LEG = "StabilizeOnRightLeg";

	// Positioning behaviors
	String ATTACK = "attack";

	String ATTACK_KICKOFF = "attackKickoff";

	String ATTACK_PENALTY = "attackPenalty";

	String GOALIE_POSITIONING = "goaliePositioning";

	String GOALIE_DRIBBLE_OR_KICK = "goalieDribbleOrKick";

	String MOVE_WITH_BALL = "moveWithBall";

	// Vision control behavior
	String TURN_HEAD = "turnHead";

	String FOCUS_BALL = "FocusBall";

	String POINT_TO_BALL = "PointToBall";

	// Unsorted behaviors

	String REMOTE_CONTROLL = "remoteControl";

	String REMOTE_COMMAND = "remoteCommand";

	String BASE_KICK = "BaseKick";

	// String COLLAPSE_BACK_BEHAVIOR = "collapseBack";

	// String DANCE1_BEHAVIOR = "dance1";

	// String GET_UP_BEHAVIOR = "getUp";

	// String TURN_AROUND_BEHAVIOR = "turnAround";

	// String STANDARD_POSITION = "standardPosition";

	// String SIMPLE_KICK_RIGHT = "simpleKickRight";

	// String KICK_RIGHT = "kickRight";

	String SIDE_KICK_RIGHT = "sideKickRight";

	String SIDE_KICK_LEFT = "sideKickLeft";

	// String TURN = "turn";

	// String TURN_LEFT = "turnLeft";

	// String TURN_RIGHT = "turnRight";

	// String START_WALK = "Accelerate";

	// String CONTINUE_WALK = "Balance";

	// String CONTINUE_RUN = "Balance";

	// String CONTINUE_WALK_RIGHT = "continueWalkRight";

	// String CONTINUE_WALK_LEFT = "continueWalkLeft";

	// String STOP_WALK = "Deccelerate";

	String SHOOT_TO_GOAL = "shootToGoal";

	// String GET_READY_PRIMITIVE = "getReadyPrimitive";

	// String RUN_TO_BALL = "runToBall";

	String PASSIVE_POSITIONING = "passivePositioning";

	// String STEP_FORWARD = "stepFront";

	// String STEP_BACKWARD = "stepBack";

	// String STEP_LEFT = "stepLeft";

	// String STEP_RIGHT = "stepRight";

	// String SIDE_STEP = "sideStep";

	String LOOK_DOWN = "lookDown";

	String GET_IN_SCORE_POSITION = "getInScorePosition";

	String DRIBBLE_BALL = "dribbleBall";

	String DRIBBLE_BALL_LEFT = "dribbleBallLeft";

	String DRIBBLE_BALL_RIGHT = "dribbleBallRight";

	String FALL_ON_SIDE = "fallOnSide";

	String FALL_FORWARD = "fallForward";

	String FALL_BACKWARD = "fallBackward";

	String SEARCH_BALL = "searchBall";

	String PUSH = "push";

	String GOALIE_STRIKE_POSITIONING = "goalieStrikePositioning";

	// String GOALIE_BEHAVIOR = "goalieBehavior";

	// String INWARD_TURN_LEFT45 = "inwardTurnLeft45";
	//
	// String INWARD_TURN_LEFT60 = "inwardTurnLeft60";
	//
	// String INWARD_TURN_RIGHT45 = "inwardTurnRight45";
	//
	// String INWARD_TURN_RIGHT60 = "inwardTurnRight60";

}
