/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.agent.behavior.basic;

import magma.agent.behavior.IBehaviorConstants;
import magma.agent.thoughtmodel.IThoughtModel;

/**
 * @author Klaus Dorer This is a class which sends each effector a command to
 *         stop
 */
public class StopBehavior extends Behavior
{
	/**  */
	private static final long serialVersionUID = 1L;

	/**
	 * Default constructor
	 * @param thoughtModel Reference to the thought model object
	 */
	public StopBehavior(IThoughtModel thoughtModel)
	{
		super(IBehaviorConstants.STOP, thoughtModel);
	}

	@Override
	public void perform()
	{
		// we send a 0.0 to each effector
		agentModel.getFutureBodyModel().resetAllMovements();
	}
}
