/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
/**
 * 
 */
package magma.agent.behavior.complex;

import java.util.Map;

import magma.agent.behavior.IBehavior;
import magma.agent.behavior.IBehaviorConstants;
import magma.agent.behavior.IWalk;
import magma.agent.thoughtmodel.IThoughtModel;
import magma.util.parameter.ParameterMap;

/**
 * Specific sideward backward walk
 * 
 * @author Klaus Dorer
 */
public class WalkSideward extends SingleComplexBehavior
{
	/**  */
	private static final long serialVersionUID = 1L;

	/**
	 * Constructor
	 * 
	 * @param thoughtModel Reference to the thought model object
	 * @param params Behavior parameters
	 * @param behaviors List of available behaviors
	 */
	public WalkSideward(IThoughtModel thoughtModel, ParameterMap params,
			Map<String, IBehavior> behaviors)
	{
		super(IBehaviorConstants.WALKSIDEWARD, thoughtModel, behaviors, behaviors
				.get(IBehaviorConstants.WALK));
	}

	@Override
	public IBehavior decideNextBasicBehavior()
	{
		IWalk walk = (IWalk) getCurrentBehavior();
		walk.walk(0, getIntensity() * 100, 0);

		return walk;
	}
}