/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/

package magma.agent.behavior.supportPoint;

import magma.agent.behavior.supportPoint.BMBStateFactory.BehaviorStateEnum;
import magma.agent.behavior.supportPoint.BasicMotorBehavior.BehaviorEvent;
import magma.util.statemachine.StateTransition;

/**
 * Transition from Starting to Running state
 */
public class BMBTransitionStartingRunning extends
		StateTransition<BehaviorStateEnum, BehaviorEvent>
{

	/**
	 * Default constructor
	 */
	public BMBTransitionStartingRunning()
	{
		super(BehaviorStateEnum.STARTING, BehaviorStateEnum.RUNNING,
				BehaviorEvent.NEXT_STEP);
	}

	/**
	 * @param context the context object
	 * @return true if the cleaner has reached the charging room
	 */
	@Override
	protected boolean checkGuardCondition(Object context)
	{
		return ((BasicMotorBehavior) context).getCurrentStep() >= 1.0;
	}

	@Override
	public void transitionAction(Object context)
	{
		((BasicMotorBehavior) context).setCurrentStep(0.0f);
	}
}
