/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/

package magma.agent.belief;

/**
 * Belief constants
 */
@SuppressWarnings("all")
public interface IBeliefConstants
{
	String WIN = "Win";

	String LOOSE = "Loose";

	String LAY_ON_FRONT = "LayOnFront";

	String LAY_ON_BACK = "LayOnBack";

	String TEAMMATE_CLOSER_TO_BALL = "teammateCloserToBall";

	String BALL_KICKABLE = "ballKickable";

	String FACING_KICK_DIRECTION = "facingKickDirection";

	String SOCCER_POSITION = "soccerPosition";

	String GAME_RUNNING = "gameRunning";

	String BEAM_TIME = "beamTime";

	// String STANDING = "standing";

	String LAY_ON_SIDE = "layOnSide";

	String PLAY_DEFENSE = "defensive";

	String PLAY_OFFENSE = "offensive";

	String BALL_IN_CRITICAL_AREA = "ballInCriticalArea";

	String BALL_IN_PENALTY_AREA = "ballInPenaltyArea";

	String BALL_IN_OWN_HALF = "ballInOwnHalf";

	String BALL_IN_SCORABLE_AREA = "ballInScorableArea";

	String OWN_KICK_OFF = "ownKickOff";

	String OPPONENT_KICK_OFF = "opponentKickOff";

	String OWN_KICK_IN = "ownKickIn";

	String OPPONENT_KICK_IN = "opponentKickIn";

	String OWN_CORNER_KICK = "ownCornerKick";

	String OPPONENT_CORNER_KICK = "opponentCornerKick";

	String OWN_GOAL_KICK = "ownGoalKick";

	String OPPONENT_GOAL_KICK = "opponentGoalKick";

	String OWN_FREE_KICK = "ownFreeKick";

	String OPPONENT_FREE_KICK = "opponentFreeKick";

	String FACING_ADV_KICK_DIRECTION = "facingAdvKickDirection";

	String FACING_GOAL_KICK_DIRECTION = "facingGoalKickDirection";

	String BALL_ENDS_UP_IN_GOAL = "ballEndsUpInGoal";

	String BALL_IS_KEEPABLE = "ballIsKeepable";

	String OPPONENT_NEAR_BALL = "opponentNearBall";

	String SHOULD_WE_DRIBBLE = "shouldWeDribble";

	String GOALIE_SHOULD_KICK = "goalieShouldKick";

	String SEE_BALL = "seeBall";

	String TEMPERATURE_HOT = "temperatureHot";

	String OPPONENT_WILL_KICK = "opponentWillKick";

	// Flags
	String PENALTY_SHOOT_OUT = "penaltyShootOut";

	String PAUSING = "hardPausing";

	String SOFT_PAUSING = "softPausing";
}
