/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.agent.belief.impl;

import magma.agent.thoughtmodel.IThoughtModel;
import magma.agent.worldmodel.GameState;

/**
 * GameState belief
 * 
 * @author Stefan Glaser
 */
public class GameStateBelief extends Belief
{
	private final GameState gameState;

	/**
	 * Constructor
	 * 
	 * @param name Belief name
	 * @param agentModel Reference to the thought model object
	 * @param gameState Current GameState
	 */
	public GameStateBelief(String name, IThoughtModel thoughtModel,
			GameState gameState)
	{
		super(name, thoughtModel);
		this.gameState = gameState;
	}

	@Override
	public float getTruthValue()
	{
		return worldModel.getGameState() == gameState ? 1f : 0f;
	}
}
