/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.agent.belief.impl;

import magma.agent.belief.IBeliefConstants;
import magma.agent.thoughtmodel.IThoughtModel;

/**
 * @author Stefan Glaser, Srinivasa Ragavan
 * 
 */
public final class LayOnFront extends Belief
{
	/**
	 * Default constructor
	 * 
	 * @param agentModel Reference to the thought model object
	 */
	public LayOnFront(IThoughtModel thoughtModel)
	{
		super(IBeliefConstants.LAY_ON_FRONT, thoughtModel);
	}

	@Override
	public float getTruthValue()
	{
		double[][] orientation = worldModel.getThisPlayer().getOrientation()
				.getMatrix();

		if (orientation[2][1] < -0.75) {
			return 1.0f;
		}

		if (orientation[2][1] < 0 && orientation[2][2] < -0.3) {
			return 1.0f;
		}

		return 0.0f;
	}
}
