/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.agent.belief.impl;

import magma.agent.belief.IBeliefConstants;
import magma.agent.thoughtmodel.IThoughtModel;
import magma.agent.worldmodel.IPlayer;
import magma.agent.worldmodel.IThisPlayer;

/**
 * Checks if any teammate is closer to the ball
 * 
 * @author Klaus Dorer
 */
public class TeammateCloserToBall extends Belief
{

	/**
	 * Constructor
	 * 
	 * @param agentModel Reference to the thought model object
	 */
	public TeammateCloserToBall(IThoughtModel thoughtModel)
	{
		super(IBeliefConstants.TEAMMATE_CLOSER_TO_BALL, thoughtModel);
	}

	@Override
	public float getTruthValue()
	{
		IThisPlayer thisPlayer = worldModel.getThisPlayer();
		IPlayer playerAtBall = thoughtModel.getClosestOwnPlayerAtBall();
		if (playerAtBall == thisPlayer) {
			return 0.0f;
		}
		return 1.0f;
	}
}
