/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 */

package magma.agent.communication.base;

import java.util.logging.Logger;

import magma.agent.communication.IChannel;
import magma.agent.communication.IChannelManager;
import magma.agent.communication.IChannelState;

/**
 * 
 * @author kdorer
 */
public abstract class ChannelBase implements IChannel
{
	/** handle for logging */
	protected static final Logger logger = Logger.getLogger("");

	/** the channel manager to inform about new messages */
	private final IChannelManager manager;

	/** state of this connection */
	protected IChannelState state;

	public ChannelBase(IChannelManager manager)
	{
		this.manager = manager;
		state = new ChannelState();
	}

	/**
	 * @return the manager
	 */
	public IChannelManager getManager()
	{
		return manager;
	}

	/**
	 * @return the state
	 */
	@Override
	public IChannelState getConnectionState()
	{
		return state;
	}

	/**
	 * 
	 * @return true if this channel is connected
	 */
	@Override
	public boolean isConnected()
	{
		return state.isConnected();
	}
}
