/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.agent.meta.agent.impl;

import magma.agent.meta.agent.ISensorConfiguration;

/**
 * Sensor configuration
 * 
 * @author Stefan Glaser
 */
public class SensorConfiguration implements ISensorConfiguration
{
	private static final long serialVersionUID = 8205062842613294927L;

	private final String name;

	private final String perceptorName;

	/**
	 * Constructor
	 * 
	 * @param name Sensor name
	 * @param perceptorName Perceptor name
	 */
	public SensorConfiguration(String name, String perceptorName)
	{
		this.name = name;
		this.perceptorName = perceptorName;
	}

	@Override
	public String getName()
	{
		return name;
	}

	@Override
	public String getPerceptorName()
	{
		return perceptorName;
	}
}
