/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 */

package magma.agent.perception.impl;

import java.util.HashMap;
import java.util.Map;

import magma.agent.perception.IPerceptor;
import magma.agent.perception.IServerMessageParser;
import magma.agent.perception.PerceptorConversionException;

/**
 * Parses Remote commands
 * @author kdorer
 */
public class CommandParser implements IServerMessageParser
{
	@Override
	public Map<String, IPerceptor> parseMessage(byte[] message)
			throws PerceptorConversionException
	{
		Map<String, IPerceptor> map = new HashMap<String, IPerceptor>();
		String command = new String(message);
		System.out.println("received: " + command);
		IPerceptor percept = new CommandPerceptor(command);
		map.put(percept.getName(), percept);
		return map;
	}
}
