/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 * 
 * This file is part of magmaOffenburg.
 * 
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg.  If not, see <http://www.gnu.org/licenses/>.
 ********************************************************************************/
package magma.agent.thoughtmodel.strategy.impl.roles;

import magma.agent.meta.server.impl.RelativeHomePosition;
import magma.agent.worldmodel.IGlobalMap;
import magma.util.geometry.Angle;
import magma.util.geometry.Pose2D;

/**
 * @author Stephan Kammerer
 */
public class Goalkeeper extends Role
{
	public Goalkeeper(String name, RelativeHomePosition relativeHomePosition,
			float priority)
	{
		super(name, relativeHomePosition, priority, -100, 100);
	}

	@Override
	protected Pose2D determinePosition(IGlobalMap worldModel)
	{
		return new Pose2D(homePosition.getHomePosition(
				worldModel.fieldHalfLength(), worldModel.fieldHalfWith()),
				Angle.ZERO);
	}
}
