/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 * 
 * This file is part of magmaOffenburg.
 * 
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg.  If not, see <http://www.gnu.org/licenses/>.
 ********************************************************************************/
package magma.agent.thoughtmodel.strategy.impl.strategies;

import magma.agent.thoughtmodel.strategy.impl.IRoleConstants;
import magma.agent.thoughtmodel.strategy.impl.roles.BallAcceptor;
import magma.agent.thoughtmodel.strategy.impl.roles.Ballguard;
import magma.agent.thoughtmodel.strategy.impl.roles.Defender;
import magma.agent.thoughtmodel.strategy.impl.roles.Goalkeeper;
import magma.agent.thoughtmodel.strategy.impl.roles.Wing;
import magma.agent.worldmodel.IGlobalMap;

/**
 * @author Stephan Kammerer
 */
public class AcceptorStrategy extends BaseStrategy
{
	public AcceptorStrategy(IGlobalMap worldModel)
	{
		availableRoles.add(new Goalkeeper("goalie", IRoleConstants.GOAL_KEEPER,
				1.0f));

		// Instantiate defender with its name, home position and priority
		availableRoles.add(new Defender("LeftDefender", worldModel,
				IRoleConstants.LEFT_INNER_DEFENDER, 7.0f));
		availableRoles.add(new Defender("RightDefender", worldModel,
				IRoleConstants.RIGHT_INNER_DEFENDER, 7.0f));
		availableRoles.add(new BallAcceptor("BallAcceptor", worldModel,
				IRoleConstants.RIGHT_DEFENDER, 8f));

		// Instantiate guards with its name, home position, offset (in
		// x-direction) and priority
		availableRoles.add(new Ballguard("LeftSupportguard", worldModel, 5.0f,
				IRoleConstants.LEFT_SUPPORTGUARD, 2.0f));
		availableRoles.add(new Ballguard("CenterSupportguard", worldModel, 3.5f,
				IRoleConstants.CENTER_SUPPORTGUARD, 3.0f));
		availableRoles.add(new Ballguard("RightSupportguard", worldModel, 5.0f,
				IRoleConstants.RIGHT_SUPPORTGUARD, 2.0f));
		availableRoles.add(new Ballguard("LeftBallguard", worldModel, 1.5f,
				IRoleConstants.LEFT_BALLGUARD, 4f));

		availableRoles.add(new Wing("Wing", worldModel,
				IRoleConstants.WING_COMMANDER, 9.0f, 5.0f));

		availableRoles.add(new Ballguard("CenterBallguard", worldModel, 2.3f,
				IRoleConstants.CENTER_BALLGUARD, 1.0f));
		availableRoles.add(new Ballguard("RightBallguard", worldModel, 1.8f,
				IRoleConstants.RIGHT_BALLGUARD, 4f));
	}
}
