/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 * 
 * This file is part of magmaOffenburg.
 * 
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg.  If not, see <http://www.gnu.org/licenses/>.
 ********************************************************************************/
package magma.agent.thoughtmodel.strategy.impl.strategies;

import java.util.ArrayList;
import java.util.List;

import magma.agent.thoughtmodel.strategy.IRole;
import magma.agent.thoughtmodel.strategy.ITeamStrategy;

/**
 * @author Stephan Kammerer
 */
public class BaseStrategy implements ITeamStrategy
{
	/** All available roles which can be applied */
	protected final ArrayList<IRole> availableRoles;

	public BaseStrategy()
	{
		availableRoles = new ArrayList<IRole>();
	}

	@Override
	public List<IRole> getAvailableRoles()
	{
		return availableRoles;
	}

	@Override
	public IRole getRoleForPlayerID(int playerID)
	{
		if (playerID < 1 || availableRoles.size() < playerID) {
			return null;
		}

		return availableRoles.get(playerID - 1);
	}
}
