/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.agent.worldmodel.impl;

import magma.agent.worldmodel.localizer.ILocalizationLine;

import org.apache.commons.math3.geometry.euclidean.threed.Vector3D;

/**
 * A simple class, holding an unlabeled reference line, which can be used for
 * localization.
 * 
 * @author Stefan Glaser
 * 
 */
public class LocalizationLine implements ILocalizationLine
{
	private Vector3D position1;

	private Vector3D position2;

	/**
	 * Creates a simple LocalizationLine with the two positions.
	 * 
	 * @param position1 - the first observed position of the line
	 * @param position2 - the second observed position of the line
	 */
	public LocalizationLine(Vector3D position1, Vector3D position2)
	{
		this.position1 = position1;
		this.position2 = position2;
	}

	@Override
	public Vector3D getLocalPosition1()
	{
		return position1;
	}

	@Override
	public Vector3D getLocalPosition2()
	{
		return position2;
	}
}
