/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.robots;

import magma.agent.general.AgentRuntime;
import magma.agent.general.PlayerParameters;

/**
 * This is the main class of the application used to start the magma Robocup
 * agent.
 * 
 * @author Klaus Dorer
 */
public class RoboCupClient
{
	/**
	 * Instantiates and starts an agent. For command line arguments see
	 * CommandLineParser
	 * @see magma.robots.CommandLineParser
	 */
	public static void main(String[] args)
	{
		PlayerParameters params = CommandLineParser.parse(args);
		AgentRuntime client = new AgentRuntime(params);
		client.startClient();
	}
}
