/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.robots.nao;

import org.apache.commons.math3.geometry.euclidean.threed.Vector3D;

public interface INaoConstants
{
	// Measured/Learned constants
	/** The maximum distance we are able to kick */
	float KICKABLE_DISTANCE = 4.6f;

	// General constants
	String ACTION_SCENE = "rsg/agent/nao/nao.rsg";

	String ACTION_SCENE_HETERO = "rsg/agent/nao/nao_hetero.rsg";

	String ACTION_SCENE_HETERO_TOE = "rsg/agent/nao/nao_hetero.rsg";

	float MAX_JOINT_SPEED = 7.03f;

	float PLAYER_HEIGHT = 0.6531f;

	Vector3D STATIC_PIVOT_POINT = new Vector3D(0, 0, -0.075);

	// Joint Constants
	String NeckYaw = "NeckYaw";

	String NeckPitch = "NeckPitch";

	String RShoulderPitch = "RShoulderPitch";

	String LShoulderPitch = "LShoulderPitch";

	String RShoulderYaw = "RShoulderYaw";

	String LShoulderYaw = "LShoulderYaw";

	String RArmRoll = "RArmRoll";

	String LArmRoll = "LArmRoll";

	String RArmYaw = "RArmYaw";

	String LArmYaw = "LArmYaw";

	String RHipYawPitch = "RHipYawPitch";

	String LHipYawPitch = "LHipYawPitch";

	String RHipRoll = "RHipRoll";

	String LHipRoll = "LHipRoll";

	String RHipPitch = "RHipPitch";

	String LHipPitch = "LHipPitch";

	String RKneePitch = "RKneePitch";

	String LKneePitch = "LKneePitch";

	String RFootPitch = "RFootPitch";

	String LFootPitch = "LFootPitch";

	String RFootRoll = "RFootRoll";

	String LFootRoll = "LFootRoll";

	String RToePitch = "RToePitch";

	String LToePitch = "LToePitch";

	// Body part Constants
	String Torso = "torso";

	String Head = "head";

	String Neck = "neck";

	String RShoulder = "rshoulder";

	String RUpperArm = "rupperarm";

	String RElbow = "relbow";

	String RLowerArm = "rlowerarm";

	String LShoulder = "lshoulder";

	String LUpperArm = "lupperarm";

	String LElbow = "lelbow";

	String LLowerArm = "llowerarm";

	String RHip1 = "rhip1";

	String RHip2 = "rhip2";

	String RThight = "rthight";

	String RShank = "rshank";

	String RAnkle = "rankle";

	String RFoot = "rfoot";

	String RToe = "rtoe";

	String LHip1 = "lhip1";

	String LHip2 = "lhip2";

	String LThight = "lthight";

	String LShank = "lshank";

	String LAnkle = "lankle";

	String LFoot = "lfoot";

	String LToe = "ltoe";

	// GyroRate-Constants
	String TorsoGyro = "TorsoGyro";

	// Accelerometer-Constants
	String TorsoAccelerometer = "TorsoAccel";

	// ForceResistance-Constants
	String RFootForce = "RFootForce";

	String LFootForce = "LFootForce";

	String RToeForce = "RToeForce";

	String LToeForce = "LToeForce";
}
