/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.robots.nao.behavior.basic;

import magma.agent.behavior.IBehaviorConstants;
import magma.agent.behavior.basic.Behavior;
import magma.agent.thoughtmodel.IThoughtModel;
import magma.robots.nao.INaoConstants;

/**
 * @author ischindl
 * 
 */
public class Cry extends Behavior
{

	/**  */
	private static final long serialVersionUID = 1L;

	private boolean pos = true;

	/**
	 * Default constructor
	 * 
	 * @param thoughtModel Reference to the thought model object
	 */
	public Cry(IThoughtModel thoughtModel)
	{
		super(IBehaviorConstants.LOOSE, thoughtModel);
	}

	@Override
	public void perform()
	{
		if (pos) {
			agentModel.getWriteableHJ(INaoConstants.NeckYaw).performAxisPosition(
					-45, 4);
			if (agentModel.getHJ(INaoConstants.NeckYaw).getAxis() < -43) {
				pos = !pos;
			}
		} else {
			agentModel.getWriteableHJ(INaoConstants.NeckYaw).performAxisPosition(
					45, 4);
			if (agentModel.getHJ(INaoConstants.NeckYaw).getAxis() > 43) {
				pos = !pos;
			}
		}

		agentModel.getWriteableHJ(INaoConstants.NeckPitch).performAxisPosition(
				-45);

		agentModel.getWriteableHJ(INaoConstants.RShoulderPitch)
				.performAxisPosition(-22);
		agentModel.getWriteableHJ(INaoConstants.LShoulderPitch)
				.performAxisPosition(-22);

		agentModel.getWriteableHJ(INaoConstants.RShoulderYaw)
				.performAxisPosition(0);
		agentModel.getWriteableHJ(INaoConstants.LShoulderYaw)
				.performAxisPosition(0);

		agentModel.getWriteableHJ(INaoConstants.RArmYaw).performAxisPosition(90);
		agentModel.getWriteableHJ(INaoConstants.LArmYaw).performAxisPosition(-90);

		agentModel.getWriteableHJ(INaoConstants.RArmRoll).performAxisPosition(38);
		agentModel.getWriteableHJ(INaoConstants.LArmRoll)
				.performAxisPosition(-38);

		agentModel.getWriteableHJ(INaoConstants.RHipPitch).performAxisPosition(
				20 + 35, 3);
		agentModel.getWriteableHJ(INaoConstants.LHipPitch).performAxisPosition(
				20 + 35, 3);

		agentModel.getWriteableHJ(INaoConstants.RFootPitch).performAxisPosition(
				-7 + 35, 2);
		agentModel.getWriteableHJ(INaoConstants.LFootPitch).performAxisPosition(
				-7 + 35, 2);

		agentModel.getWriteableHJ(INaoConstants.RKneePitch).performAxisPosition(
				-65);
		agentModel.getWriteableHJ(INaoConstants.LKneePitch).performAxisPosition(
				-65);
	}

}
