/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.robots.nao.behavior.basic;

import magma.agent.behavior.IBehaviorConstants;
import magma.agent.behavior.basic.Behavior;
import magma.agent.thoughtmodel.IThoughtModel;
import magma.robots.nao.INaoConstants;

/**
 * @author ischindl
 * 
 */
public class Dance extends Behavior
{

	/**  */
	private static final long serialVersionUID = 1L;

	private double i = 0;

	/**
	 * Default constructor
	 * 
	 * @param thoughtModel Reference to the thought model object
	 */
	public Dance(IThoughtModel thoughtModel)
	{
		super(IBehaviorConstants.WIN, thoughtModel);
	}

	@Override
	public void perform()
	{
		i += 0.09;
		// Vector3d com = agentModel.getCoM().getPosition();

		double sin = Math.sin(i) * 10;
		double cos = Math.cos(i) * 5;
		// System.out.println(sin + "\t" + cos);

		agentModel.getWriteableHJ(INaoConstants.RShoulderPitch)
				.performAxisPosition(80 + cos, 2);
		agentModel.getWriteableHJ(INaoConstants.LShoulderPitch)
				.performAxisPosition(80 + cos, 2);
		agentModel.getWriteableHJ(INaoConstants.RShoulderYaw)
				.performAxisPosition(-sin);
		agentModel.getWriteableHJ(INaoConstants.LShoulderYaw)
				.performAxisPosition(-sin);

		agentModel.getWriteableHJ(INaoConstants.RHipRoll).performAxisPosition(
				-sin);
		agentModel.getWriteableHJ(INaoConstants.LHipRoll).performAxisPosition(
				-sin);
		agentModel.getWriteableHJ(INaoConstants.RFootRoll).performAxisPosition(
				sin);
		agentModel.getWriteableHJ(INaoConstants.LFootRoll).performAxisPosition(
				sin);

		agentModel.getWriteableHJ(INaoConstants.RHipPitch).performAxisPosition(
				-cos + 35, 4);
		agentModel.getWriteableHJ(INaoConstants.LHipPitch).performAxisPosition(
				-cos + 35, 4);
		agentModel.getWriteableHJ(INaoConstants.RFootPitch).performAxisPosition(
				cos + 35, 4);
		agentModel.getWriteableHJ(INaoConstants.LFootPitch).performAxisPosition(
				cos + 35, 4);

		agentModel.getWriteableHJ(INaoConstants.RKneePitch).performAxisPosition(
				-65);
		agentModel.getWriteableHJ(INaoConstants.LKneePitch).performAxisPosition(
				-65);

		agentModel.getWriteableHJ(INaoConstants.RArmYaw)
				.performAxisPosition(0, 2);
		agentModel.getWriteableHJ(INaoConstants.LArmYaw)
				.performAxisPosition(0, 2);

	}
}
