/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.robots.nao.behavior.dynamic.walk;

import magma.util.parameter.Parameter;

/**
 * Represents the parameter set necessary for walking forwards
 * 
 * @author Ingo Schindler
 * 
 *         What exactly this parameters are is documented in my Bachelor-Thesis
 *         (Bipedal-Walking in the simulated RoboCup-3D environment)
 */
public class ForwardWalkBehaviorParameter extends WalkBehaviorParameter
{
	private static final long serialVersionUID = -2324636896847512436L;

	public ForwardWalkBehaviorParameter(Parameter[] params)
	{
		super(params);
		// add special settings here for walking forward
	}

	public static ForwardWalkBehaviorParameter getInstance()
	{
		ForwardWalkBehaviorParameter result = new ForwardWalkBehaviorParameter(
				createParams());
		result.setValues();
		return result;
	}
}
