/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
/**
 * 
 */
package magma.robots.nao.behavior.dynamic.walk;

import magma.util.parameter.IParameterList;

/**
 * @author Maximilian
 * 
 */
public class WalkSituation
{

	/** Splines that represent the Ankle-Movement */
	private Ankle ankle;

	/**  */
	private WalkBehaviorParameter parameter;

	/** Spline that represents the Hip-Movement */
	private Hip hip;

	/** Offset for i from one Footstep to another */
	private double stepOffset;

	public WalkSituation(IParameterList params, WalkMode mode)
	{
		if ((params instanceof WalkBehaviorParameter)
				&& mode == ((WalkBehaviorParameter) params).getMode()) {
			this.parameter = (WalkBehaviorParameter) params;
		} else {
			this.parameter = WalkBehaviorParameter.getInstance();
		}
		this.ankle = new Ankle(this.parameter);
		this.hip = new Hip(this.parameter);
		this.stepOffset = ankle.getLen() / 2;
	}

	Ankle getAnkle()
	{
		return ankle;
	}

	WalkBehaviorParameter getParameter()
	{
		return parameter;
	}

	Hip getHip()
	{
		return hip;
	}

	double getStepOffset()
	{
		return stepOffset;
	}

}
