/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/

package magma.robots.nao.behavior.movement;

import magma.agent.behavior.IBehaviorConstants;
import magma.agent.behavior.movement.Movement;
import magma.agent.behavior.movement.MovementBehavior;
import magma.agent.behavior.movement.MovementPhase;
import magma.agent.thoughtmodel.IThoughtModel;
import magma.robots.nao.INaoConstants;

/**
 * @author Klaus Dorer
 * 
 */
public class FallBack extends MovementBehavior
{
	/**  */
	private static final long serialVersionUID = 1L;

	/** movement to jump to the right */
	protected Movement fall;

	/**
	 * Default constructor
	 * 
	 * @param thoughtModel Reference to the thought model object
	 */
	public FallBack(IThoughtModel thoughtModel)
	{
		this(IBehaviorConstants.FALL_BACKWARD, thoughtModel);
	}

	/**
	 * Default constructor
	 * 
	 * @param name - the name of the behavior
	 * @param thoughtModel Reference to the thought model object
	 */
	public FallBack(String name, IThoughtModel thoughtModel)
	{
		super(name, thoughtModel);

		fall = new Movement("fallBack");
		fall.add(new MovementPhase("phase1", 10) //
				.add(INaoConstants.LFootPitch, -60, 7f) //
				.add(INaoConstants.RFootPitch, -60, 7f) //
		);
		currentMovement = fall;
	}

	@Override
	protected Movement getInitialMovement()
	{
		return fall;
	}
}
