/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.robots.nao.behavior.movement;

import magma.util.parameter.Parameter;

/**
 * Represents the parameter set necessary for kicking with KickChipRight
 * 
 * @author Alexander Derr
 */
public class KickChipRightBehaviorParameters extends KickFastBehaviorParameter
{
	private static final long serialVersionUID = -2023337834886252673L;

	/**
	 * @param params
	 */
	protected KickChipRightBehaviorParameters(Parameter[] params)
	{
		super(params);
	}

	@Override
	protected void setValues()
	{
		super.setValues();
		// setValue(Param.TIME1, -2.0f);
		// setValue(Param.TIME2, 4.0f);
		// setValue(Param.TIME3, 3.0f);
		setValue(Param.LHP1, -5.0f);
		setValue(Param.RHP1, 70.0f);
		setValue(Param.RKP1, -24.0f);
		setValue(Param.RFP1, 7.0f);
		setValue(Param.LHP2, -10.0f);
		// setValue(Param.RHYP2, -58.0f);
		setValue(Param.RHP2, 18.0f);
		setValue(Param.RKP2, -10.0f);
		setValue(Param.RFP2, 5.0f);
		// setValue(Param.RKPS1, 5.0f);
		// setValue(Param.RHPS2, 3.0f);
		// setValue(Param.RHYPS2, 4.999999f);
		// setValue(Param.RFPS2, 4.0f);
		setValue(Param.RROLL, -12.0f);
		setValue(Param.LROLL, 9.0f);
		setValue(Param.POSX, 3f);
		// setValue(Param.POSY, -0.11f);
	}

	public static KickChipRightBehaviorParameters getInstance()
	{
		KickChipRightBehaviorParameters result = new KickChipRightBehaviorParameters(
				createParams());
		result.setValues();
		return result;
	}
}
