/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.robots.nao.behavior.movement;

import magma.util.parameter.Parameter;

/**
 * Represents the parameter set necessary for kicking with KickStraightModel
 * 
 * @author Klaus Dorer
 */
public class KickSlomoBehaviorParameter extends
		KickStraightOneLegBehaviorParameter
{

	private static final long serialVersionUID = -2324636896847512436L;

	/**
	 * @param params
	 */
	protected KickSlomoBehaviorParameter(Parameter[] params)
	{
		super(params);
	}

	@Override
	protected void setValues()
	{
		super.setValues();
		// start values for search
		setValue(Param.TIME1, 45f);
		setValue(Param.RHYP2, 0.8f);
	}

	public static KickSlomoBehaviorParameter getInstance()
	{
		KickSlomoBehaviorParameter result = new KickSlomoBehaviorParameter(
				createParams());
		result.setValues();
		return result;
	}

}
