/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.robots.nao.behavior.movement;

import magma.util.parameter.Parameter;

/**
 * Represents the parameter set necessary for kicking with KickStraightModel
 * 
 * @author Klaus Dorer
 */
public class KickStraightOneLegBehaviorParameter extends
		KickFastBehaviorParameter
{

	private static final long serialVersionUID = -2324636896847512436L;

	/**
	 * @param params
	 */
	protected KickStraightOneLegBehaviorParameter(Parameter[] params)
	{
		super(params);
	}

	@Override
	protected void setValues()
	{
		super.setValues();

		// utility measured local 4.32
		setValue(Param.TIME1, 1.0f);
		setValue(Param.TIME2, 4.0f);
		setValue(Param.TIME3, 5.0f);
		setValue(Param.LHP1, 3.0f);
		setValue(Param.RHP1, -20.0f);
		setValue(Param.RKP1, -72.0f);
		setValue(Param.RFP1, 30.0f);
		setValue(Param.LHP2, -16.0f);
		setValue(Param.RHYP2, -58.0f);
		setValue(Param.RHP2, 61.0f);
		setValue(Param.RKP2, 6.0f);
		setValue(Param.RFP2, -27.0f);
		setValue(Param.RKPS1, 5.0f);
		setValue(Param.RHPS2, 3.0f);
		setValue(Param.RHYPS2, 4.0f);
		setValue(Param.RFPS2, 4.0f);
		setValue(Param.RROLL, -10.0f);
		setValue(Param.LROLL, 12.0f);
		setValue(Param.POSX, 0.12f);
		setValue(Param.POSY, -0.10f);
		setValue(Param.BEAMX, -1.1f);
		setValue(Param.BEAMY, 0f);
	}

	public static KickStraightOneLegBehaviorParameter getInstance()
	{
		KickStraightOneLegBehaviorParameter result = new KickStraightOneLegBehaviorParameter(
				createParams());
		result.setValues();
		return result;
	}

}
