/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 * 
 * This file is part of magmaOffenburg.
 * 
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg.  If not, see <http://www.gnu.org/licenses/>.
 ********************************************************************************/
package magma.util.file;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

/**
 * @author Stefan Glaser, Klaus Dorer
 */
public class LogfileReader
{
	private File logsrc;

	private BufferedReader br;

	public LogfileReader(File file)
	{
		this.logsrc = file;
	}

	public String next()
	{
		String currentMessage;
		try {
			currentMessage = br.readLine();
		} catch (IOException e) {
			e.printStackTrace();
			return null;
		}

		return currentMessage;
	}

	public void open() throws FileNotFoundException
	{
		try {
			br = TarBz2ZipUtil.createBufferedReader(logsrc);
		} catch (FileNotFoundException e) {
			System.out.println("File not found: " + logsrc + " " + e.getMessage());
			throw e;
		}
	}

	public void close()
	{
		try {
			br.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
