/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 */

package magma.util.file;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

/**
 * 
 * @author kdorer
 */
public class StreamBufferer
{
	private InputStream in;

	private StringBuffer buffer;

	private int maxSize;

	public StreamBufferer(InputStream in, int maxSize)
	{
		this.in = in;
		this.maxSize = maxSize;
		ConsumerThread t = new ConsumerThread();
		t.start();
	}

	class ConsumerThread extends Thread
	{
		@Override
		public void run()
		{
			BufferedReader reader = new BufferedReader(new InputStreamReader(in));
			String line;
			try {
				buffer = new StringBuffer(maxSize);
				while ((line = reader.readLine()) != null) {
					buffer.append(line);
					if (buffer.length() > maxSize) {
						buffer.delete(0, buffer.length() - maxSize + 100);
					}
				}
				reader.close();
			} catch (IOException e) {
				// e.printStackTrace();
			}
		}
	}

	public String getBuffer()
	{
		return buffer.toString();
	}
}
