/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 * 
 * This file is part of magmaOffenburg.
 * 
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg.  If not, see <http://www.gnu.org/licenses/>.
 ********************************************************************************/
package magma.util.function;

import org.apache.commons.math3.geometry.euclidean.twod.Vector2D;

/**
 * A simple class representing a two dimensional point for functions.
 * 
 * @author Stefan Glaser
 */
public class Point implements IPoint
{
	/** The x coordinate of the point */
	protected float x;

	/** The y coordinate of the point */
	protected float y;

	public Point()
	{
		this(0, 0);
	}

	public Point(float x, float y)
	{
		this.x = x;
		this.y = y;
	}

	public Point(Point source)
	{
		this.x = source.x;
		this.y = source.y;
	}

	@Override
	public float getX()
	{
		return x;
	}

	@Override
	public float getY()
	{
		return y;
	}

	protected void setX(float x)
	{
		this.x = x;
	}

	protected void setY(float y)
	{
		this.y = y;
	}

	protected void set(float x, float y)
	{
		this.x = x;
		this.y = y;
	}

	protected void move(float xMove, float yMove)
	{
		this.x += xMove;
		this.y += yMove;
	}

	@Override
	public Vector2D asVector2D()
	{
		return new Vector2D(x, y);
	}
}
