/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 * 
 * This file is part of magmaOffenburg.
 * 
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg.  If not, see <http://www.gnu.org/licenses/>.
 ********************************************************************************/
package magma.util.geometry;

/**
 * 
 * @author Stefan Grossmann
 *
 */
public class Tangente
{
	/** startpoint */
	private Pose2D p1;

	/** endpoint */
	private Pose2D p2;

	public Tangente(Pose2D p1, Pose2D p2)
	{
		this.p1 = p1;
		this.p2 = p2;
	}

	@Override
	public boolean equals(Object other)
	{
		Tangente t = (Tangente) other;
		if ((this.p1.equals(t.p1) && this.p2.equals(t.p2))
				|| (this.p1.equals(t.p2) && this.p2.equals(t.p1)))
			return true;
		return false;
	}

	// Getter and Setter
	public Pose2D getP1()
	{
		return p1;
	}

	public void setP1(Pose2D p1)
	{
		this.p1 = p1;
	}

	public Pose2D getP2()
	{
		return p2;
	}

	public void setP2(Pose2D p2)
	{
		this.p2 = p2;
	}
}
