/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 * 
 * This file is part of magmaOffenburg.
 * 
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg.  If not, see <http://www.gnu.org/licenses/>.
 ********************************************************************************/
package magma.util.geometry.interpolation;

import java.io.Serializable;

import magma.util.geometry.Pose6D;

/**
 * Interface for a pose interpolator.
 * 
 * @author Stefan Glaser
 */
public interface IPoseInterpolator extends Serializable
{
	/**
	 * @param initialPose: the initial pose
	 * @param targetPose: the target pose
	 * @param t: the interpolation progress (0...1)
	 * @return the interpolated pose
	 */
	public Pose6D interpolate(Pose6D initialPose, Pose6D targetPose, float t);
}
