/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 * 
 * This file is part of magmaOffenburg.
 * 
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg.  If not, see <http://www.gnu.org/licenses/>.
 ********************************************************************************/
package magma.util.geometry.interpolation.value;

import magma.util.ValueUtil;
import magma.util.geometry.interpolation.progress.LinearProgress;

/**
 * @author Stefan Glaser
 */
public class AbsMaxSinusLinearValueInterpolator extends
		SinusLinearValueInterpolator
{
	/** */
	private static final long serialVersionUID = 6805512727933305795L;

	public double absMax;

	public AbsMaxSinusLinearValueInterpolator(double absMax)
	{
		super(new LinearProgress(), 0);
		this.absMax = absMax;
	}

	@Override
	protected double calculateInterpolationValue(double initial, double target,
			float t)
	{
		double lin = (target - initial) * t;
		double sin = Math.sin(t * Math.PI) * amplitude;
		sin = ValueUtil.limitAbs(sin, absMax);

		return initial + lin + sin;
	}
}
