/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 * 
 * This file is part of magmaOffenburg.
 * 
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg.  If not, see <http://www.gnu.org/licenses/>.
 ********************************************************************************/
package magma.util.geometry.interpolation.value;

import magma.util.geometry.interpolation.progress.LinearProgress;
import magma.util.geometry.interpolation.progress.ProgressFunction;

/**
 * @author Stefan Glaser
 */
public class LinearValueInterpolator extends ValueInterpolatorBase
{
	/** */
	private static final long serialVersionUID = -876294240784038840L;

	public LinearValueInterpolator()
	{
		this(new LinearProgress());
	}

	public LinearValueInterpolator(ProgressFunction progress)
	{
		super(progress);
	}

	@Override
	protected double calculateInterpolationValue(double initial, double target,
			float t)
	{
		return initial + ((target - initial) * t);
	}
}
