/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 */

package magma.util.parameter;

/**
 * 
 * @author kdorer
 */
public interface IParameterList
{

	/**
	 * @return the array of parameters
	 */
	float[] getParameterValues();

	/**
	 * @param index the 0 based index of the parameter.
	 * @return the value of the parameter specified by index
	 */
	float getValue(int index);

	/**
	 * @param index the 0 based index of the parameter
	 * @param value the new value of the parameter
	 */
	void setValue(int index, float value);

	/**
	 * Writes the parameters to the specified file
	 * @param filename the name to use as filename
	 */
	void writeToFile(String filename);

	/**
	 * Reads the parameters from the specified file
	 * @param filepath the file to read
	 */
	void readFromFile(String filepath);

	/**
	 * @return a String version of the params that is easy to paste into code
	 */
	String getParamsString();

	/**
	 * @return the parameters
	 */
	Parameter[] getParameters();
}