/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 */

package magma.util.parameter;

import java.util.HashMap;
import java.util.Map;

/**
 * Simple Map wrapper for specific IBehaviorParameterMap
 * @author kdorer
 */
public class ParameterMap
{
	private Map<String, IParameterList> parameterMap;

	/**
	 * Default constructor
	 */
	public ParameterMap()
	{
		parameterMap = new HashMap<String, IParameterList>(20);
	}

	public void put(String key, IParameterList value)
	{
		parameterMap.put(key, value);
	}

	public void putAll(ParameterMap other)
	{
		parameterMap.putAll(other.parameterMap);
	}

	public IParameterList get(String key)
	{
		return parameterMap.get(key);
	}

	public IParameterList getFirst()
	{
		if (parameterMap.isEmpty()) {
			return null;
		}
		return parameterMap.values().iterator().next();
	}

	public boolean contains(String key)
	{
		return parameterMap.containsKey(key);
	}
}
