/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 * 
 * This file is part of magmaOffenburg.
 * 
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg.  If not, see <http://www.gnu.org/licenses/>.
 ********************************************************************************/
package magma.util.scenegraph.impl;

import magma.util.scenegraph.IBaseNode;
import magma.util.scenegraph.ITransformNode;
import magma.util.scenegraph.NodeType;

public class TransformNode extends BaseNode implements ITransformNode
{
	/** The local transformation of the node to its parent node */
	private float[] localTransform;

	public TransformNode()
	{
	}

	public TransformNode(TransformNode other)
	{
		this.localTransform = other.getLocalTransformtation();
	}

	@Override
	public NodeType getNodeType()
	{
		return NodeType.TRANSFORM_NODE;
	}

	@Override
	public float[] getLocalTransformtation()
	{
		return localTransform;
	}

	public void setLocalTransform(float[] localTransform)
	{
		this.localTransform = localTransform;
	}

	@Override
	public void update(IBaseNode other)
	{
		if (other.getNodeType() == NodeType.TRANSFORM_NODE) {
			ITransformNode newTransform = (ITransformNode) other;

			if (newTransform.getLocalTransformtation() != null) {
				localTransform = newTransform.getLocalTransformtation();
			}
		}

		super.update(other);
	}
}
