/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.util.statemachine;

/**
 * Interface to access state factories
 * 
 * @author Klaus Dorer *
 * @param <K> the enum used to identify states
 * @param <E> the enum used to identify events
 */
public interface IStateFactory<K, E>
{

	/**
	 * @param state the state enum of the state to retrieve
	 * @return the state that is associated with the state enum
	 */
	ObjectState<K, E> getState(K state);

	/**
	 * Returns the state to start with
	 * @return the state that is the first state a context object is in
	 */
	ObjectState<K, E> getInitialState();

}