/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 */

package magma.agent.meta.agent.impl;

import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.assertEquals;

/**
 * 
 * @author kdorer
 */
public class OffsetJointMapperTest
{
	private OffsetJointMapper testee;

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception
	{
		testee = new OffsetJointMapper(180, -1);
	}

	/**
	 * Test method for
	 * {@link magma.agent.meta.agent.impl.OffsetJointMapper#jointToMotorAngle(double[])}
	 * .
	 */
	@Test
	public void testJointToMotorAngle()
	{
		double[] jointAngle = { 10 };
		double[] motorAngle = testee.jointToMotorAngle(jointAngle);
		assertEquals(170, motorAngle[0], 0.001);
	}

	/**
	 * Test method for
	 * {@link magma.agent.meta.agent.impl.OffsetJointMapper#motorToJointAngle(double[])}
	 * .
	 */
	@Test
	public void testMotorToJointAngle()
	{
		double[] motorAngles = { 170 };
		double[] jointAngle = testee.motorToJointAngle(motorAngles);
		assertEquals(10, jointAngle[0], 0.001);
	}

}
