/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 */

package magma.util;

import org.junit.Test;

import static org.junit.Assert.assertEquals;

/**
 * 
 * @author kdorer
 */
public class ValueUtilTest
{
	/**
	 * Test method for {@link magma.util.ValueUtil#limitAbs(float, float)}.
	 */
	@Test
	public void testLimitAbsFloatFloat()
	{
		assertEquals(9, ValueUtil.limitAbs(10, 9), 0.001);
		assertEquals(-9, ValueUtil.limitAbs(-10, 9), 0.001);
		assertEquals(8, ValueUtil.limitAbs(8, 9), 0.001);
	}

	/**
	 * Test method for
	 * {@link magma.util.ValueUtil#getValueAdjustment(double, double, double, double)}
	 * .
	 */
	@Test
	public void testGetValueAdjustment()
	{
		assertEquals(1, ValueUtil.getValueAdjustment(5, 7, 1, 2), 0.001);
		assertEquals(-2, ValueUtil.getValueAdjustment(5, 3, 1, 2), 0.001);
		assertEquals(0.5, ValueUtil.getValueAdjustment(5, 5.5, 1, 2), 0.001);
		assertEquals(-0.5, ValueUtil.getValueAdjustment(5, 4.5, 1, 2), 0.001);
	}

	@Test
	public void testGetScale()
	{
		double[] values = { 1, -2, 3 };
		assertEquals(1, ValueUtil.getScale(values, 7), 0.001);
		assertEquals(0.5, ValueUtil.getScale(values, 3), 0.001);
	}
}
