/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 */

package magma.util.function;

import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.assertEquals;

/**
 * 
 * @author kdorer
 */
public class LookupFunctionTest
{
	private LookupFunction testee;

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception
	{
		float[] data = { 0, 1, 2, 3 };
		testee = new LookupFunction(data, 1, 0);
	}

	/**
	 * Test method for
	 * {@link magma.util.function.LookupMatrix#getValue(double, double)}.
	 */
	@Test
	public void testGetValue()
	{
		assertEquals(0, testee.getValue(0), 0.0001);
		assertEquals(3, testee.getValue(3), 0.0001);
		assertEquals(0.5, testee.getValue(0.5), 0.0001);
		assertEquals(0, testee.getValue(-3), 0.0001);
		assertEquals(3, testee.getValue(4), 0.0001);
		assertEquals(0.9, testee.getValue(0.9), 0.0001);
	}

	// commented, architecture violation, only manually triggered
	// @Test
	// public void testReadFromFile()
	// {
	// testee = new LookupFunction(
	// "motorMappings/JointToMotorLookupKneeM1LEFT.csv");
	//
	// // test difference to analytical method
	// IJointToMotorMapper mapper = new SweatyKneeJointToMotorMapper(
	// WhichKnee.LEFT);
	//
	// for (double i = 0; i < 30; i += 0.1) {
	// double[] jointAngles = { i };
	// double value1 = mapper.jointToMotorAngle(jointAngles)[0];
	// double value2 = testee.getValue(i);
	// double delta = value2 - value1;
	// if (delta > 1.0) {
	// System.out.println("Delta: " + delta + " x:" + i);
	// }
	// }
	// }
}
