/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package magma.util.logging;

import static org.junit.Assert.assertEquals;

import java.util.logging.Level;
import java.util.logging.LogRecord;

import org.junit.Before;
import org.junit.Test;

/**
 * Tests for CSV Formatter class
 */
public class CSVFormatterTest
{
	private CSVFormatter testee;

	final String lineSeparator = java.security.AccessController
			.doPrivileged(new sun.security.action.GetPropertyAction(
					"line.separator"));

	/**
	 * Setup method
	 */
	@Before
	public void setUp()
	{
		testee = new CSVFormatter();
	}

	/**
	 * Test if a message is correctly formatted
	 */
	@Test
	public void testFormat()
	{
		LogRecord record = new LogRecord(Level.INFO,
				"This is a test. Please ignore it.");

		// assertEquals("This is a test", testee.format(recordmock));
		assertEquals("This is a test, Please ignore it," + lineSeparator,
				testee.format(record));
	}
}
