/********************************************************************************
 * Copyright 2008 - 2014 Hochschule Offenburg
 * All Authors are named in file Authors.txt
 *
 * This file is part of magmaOffenburg.
 *
 * magmaOffenburg is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * magmaOffenburg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
 */

package magma.util.parameter;

import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.assertEquals;

/**
 * 
 * @author kdorer
 */
public class ParameterListTest
{
	protected ParameterList testee;

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception
	{
		Parameter[] params = new Parameter[4];
		params[0] = new Parameter("one");
		params[1] = new Parameter("two");
		params[2] = new Parameter("three");
		params[3] = new Parameter("four");
		testee = new ParameterList(params);
	}

	/**
	 * Test method for {@link magma.util.parameter.ParameterList#getParameters()}
	 * .
	 */
	@Test
	public void testGetParameters()
	{
		float[] result = testee.getParameterValues();
		assertEquals(4, result.length);
		assertEquals(0.0f, result[3], 0.0001f);
	}
}
