# Converts a comma separated time series gained from logging into
# a WEKA input file for learning.
# It scans for lines tagged as result lines and then combines the last data line with the result.
#
# gawk -f /host/Data/Programmierung/Robocup/magma/RoboCup3D/util/awk/timeSeriesExtractor.awk 2012-11-27kickSeriesRaw.csv > dataout.arff
#
BEGIN {
#	print "id;gyroX;gyroY;ballXlocal;ballYlocal;gyroXChange;gyroYChange;result"
	FS = ";"
	line=0
	instance = 0
# use when called from outside with parameter
	time = theTimeStep
#	time = 30

print "@RELATION kickRight"time
print ""
print "@ATTRIBUTE id  NUMERIC"
print "@ATTRIBUTE gyroX  NUMERIC"
print "@ATTRIBUTE gyroY   NUMERIC"
print "@ATTRIBUTE ballXlocal  NUMERIC"
print "@ATTRIBUTE ballYlocal   NUMERIC"
print "@ATTRIBUTE gyroXChange  NUMERIC"
print "@ATTRIBUTE gyroYChange   NUMERIC"

# use this for multi time arff file
print "@ATTRIBUTE gyroX10  NUMERIC"
print "@ATTRIBUTE gyroY10   NUMERIC"
print "@ATTRIBUTE ballXlocal10  NUMERIC"
print "@ATTRIBUTE ballYlocal10   NUMERIC"
print "@ATTRIBUTE gyroXChange10  NUMERIC"
print "@ATTRIBUTE gyroYChange10   NUMERIC"

print "@ATTRIBUTE gyroX20  NUMERIC"
print "@ATTRIBUTE gyroY20   NUMERIC"
print "@ATTRIBUTE ballXlocal20  NUMERIC"
print "@ATTRIBUTE ballYlocal20   NUMERIC"
print "@ATTRIBUTE gyroXChange20  NUMERIC"
print "@ATTRIBUTE gyroYChange20   NUMERIC"

print "@ATTRIBUTE result   NUMERIC"
print ""
print "@DATA"  
}

{
	if ($5 == "result" && leftFoot!="0.00") {
		instance = instance + 1
		
		# use this for a single time arff file
		#result = data[line - time]
		
		# use this to create a multi time arff file
		result = data[line]; 
		result = result ";" data[line - 10]; 
		result = result ";" data[line - 20]; 
		
		if (result != "") {
			result = instance result $6
			gsub(/\,/,".", result)
			gsub(/\;/,",", result)
			print result
		}
		delete data
		line=0
	}
	line = line + 1
	if ($5 == "data") {
		data[line] = $3  ";" $4 ";" $8 ";" $9 ";" $11 ";" $12 ";" 
		leftFoot=$7 	
	}
}