#!/bin/bash
#*******************************************************************************
# Copyright 2008, 2011 Hochschule Offenburg
# Klaus Dorer, Mathias Ehret, Stefan Glaser, Thomas Huber, Fabian Korak,
# Simon Raffeiner, Srinivasa Ragavan, Thomas Rinklin,
# Joachim Schilling, Ingo Schindler, Rajit Shahi, Bjoern Weiler
#
# This file is part of magmaOffenburg.
#
# magmaOffenburg is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# magmaOffenburg is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with magmaOffenburg. If not, see <http://www.gnu.org/licenses/>.
#*******************************************************************************
###########################################
# Extracts a series of file for inductive learning, one for each time step before the result
#
# example: bash /host/Data/Programmierung/Robocup/magma/RoboCup3D/util/awk/timeSeriesLoop.sh
###########################################


for ((TimeStep = 0 ; TimeStep < 31; TimeStep++)) do
	Filename=rightKick$TimeStep.arff
	echo $Filename
	gawk -f /host/Data/Programmierung/Robocup/magma/RoboCup3D/util/awk/timeSeriesExtractor.awk -v theTimeStep=$TimeStep 2012-11-27kickSeriesRaw.csv > $Filename
	
done
