# get on the client computers
# ssh robocup@141.79.65.128
#
# First create a file using 
# grep 'verage' lausConsole.txt > learnAverage.txt
# gawk '{print $3}' learnAverage.txt > learnAverage.csv
#
# Or both in one
# grep 'verage' lausConsole.txt | gawk '{print $3}' > learnAverage.csv
# grep 'time' lausConsole.txt | gawk '{print $3}' > learnTime.csv
#
# grep 'standing' lausConsole.txt | gawk '{print $2}'
#
# to have the series of best individuums in genetic optimization with diversity
# grep 'time' lausConsole.txt | gawk '{print $3";" $5}' > learnAverage.csv
#
# searching with grep for two words and lines not containing some markers (used for kick evaluation)
# grep 'kick\|Agent' kickResult.csv | grep -v wait | gawk '{print $2}' >2012-11-29kickSeriesWait10NoWaitScores.csv
#
# extract score from game series
# grep score trainer1.log > kickEval1.csv
#
# gawk -f /host/Data/Programmierung/Robocup/magma/RoboCup3D/util/awk/utilityExtractor.awk learnAverage.txt > learnAverage.csv
# 
# extract statistics from a single game series (local and on series server)
# grep score trainer2.log | gawk --file /host/Data/Programmierung/Robocup/magma/RoboCup3D/util/awk/utilityExtractor.awk
# grep score log/trainer1.log | gawk --file utilityExtractor.awk
#
# extract statistics from a series of game series
# for f in log/series*; do grep score $f | gawk --file utilityExtractor.awk;done
#

BEGIN {
	FS = ";"
	count = 0
}

/Running/ {
	print
} 

! /Running/ {
	count=count + 1
	average1Old = average1
	average2Old = average2
	average1 = (average1 * (count - 1) + $2) / count
	average2 = (average2 * (count - 1) + $3) / count
	averageBallX = (averageBallX * (count - 1) + $4) / count

	if (count > 2) {
		std1 = ((count-2) / (count-1)) * std1 + ($2 - average1Old)*($2 - average1Old) / count
		std2 = ((count-2) / (count-1)) * std2 + ($3 - average2Old)*($3 - average2Old) / count

		# t= (m1-m2) / (Sx1x2 * sqrt(2/n))
		# n = 2 *count -2
		# Sx1x2 = sqrt((Sx1^2 + Sx2^2) /2) 
		Sx1x2 = sqrt((std1 + std2)/2)
		df = 2 * count - 2
		if (Sx1x2 > 0) {
			t =  (average1 - average2) / (Sx1x2 * sqrt(2/df))
			if (t < 0) t=-t
		}
		
		# t-Distribution of one sided test and infinitely many degrees of freedom
		#0,75 	0,875 	0,90 	0,95 	0,975 	0,99 	0,995 	0,999
		#0,674 	1,150 	1,282 	1,645 	1,960 	2,326 	2,576 	3,090
		if (count > 100) {
			# we need a big number to have the values approximately right
			     if (t > 3.090) p = "<0.001"
			else if (t > 2.576) p = "<0.005"
			else if (t > 2.326) p = "<0.01"
			else if (t > 1.960) p = "<0.025"
			else if (t > 1.645) p = "<0.05"
			else if (t > 1.282) p = "<0.1"
			else if (t > 1.150) p = "<0.125"
			else if (t > 0.674) p = "<0.25"
			else p = ">=0.25"
		} else p = "tooFew"

		#print t ";" p ";" Sx1x2 ";" df 

	} else if (count > 1) {
		std1 = ($2 - average1)*($2 - average1) + (averag1Old - average1)*(average1Old - average1)
		std2 = ($3 - average2)*($3 - average2) + (averag2Old - average2)*(average2Old - average2)
	}	
	#print std1 ";" std2
	#print $2 ";" $3 ";" sum2
}

#END { print "m1=" average1 " m2=" average2 " n=" count " p=" p " t=" t}
END { print average1 ";" average2 ";" count ";" p ";" t ";" averageBallX}
